/* ----------------------------------------------------------------------- */
/* Šablona zdrojového kódu generovná programem Piklab */
#include <pic18f452.h>

/* ----------------------------------------------------------------------- */
/* Konfigurační bity: upravte dle vašeho nastavení a potřeb */
code char at __CONFIG1H CONFIG1H = _OSC_HS_1H;
code char at __CONFIG2L CONFIG2L = _PUT_OFF_2L & _BODEN_OFF_2L;
code char at __CONFIG2H CONFIG2H = _WDT_OFF_2H & _WDTPS_1_128_2H;
code char at __CONFIG3H CONFIG3H = _CCP2MUX_RC1_3H;
code char at __CONFIG4L CONFIG4L = _STVR_OFF_4L & _LVP_OFF_4L & _BACKBUG_OFF_4L;
code char at __CONFIG5L CONFIG5L = _CP_0_OFF_5L & _CP_1_OFF_5L & _CP_2_OFF_5L & _CP_3_OFF_5L;
code char at __CONFIG5H CONFIG5H = _CPB_OFF_5H & _CPD_OFF_5H;
code char at __CONFIG6L CONFIG6L = _WRT_0_OFF_6L & _WRT_1_OFF_6L & _WRT_2_OFF_6L & _WRT_3_OFF_6L;
code char at __CONFIG6H CONFIG6H = _WRTC_OFF_6H & _WRTB_OFF_6H & _WRTD_OFF_6H;
code char at __CONFIG7L CONFIG7L = _EBTR_0_OFF_7L & _EBTR_1_OFF_7L & _EBTR_2_OFF_7L & _EBTR_3_OFF_7L;
code char at __CONFIG7H CONFIG7H = _EBTRB_OFF_7H;

#define	POCET_SOUBORU	3

char velikost; // Prepinani velkych/malych pismen
unsigned char buffer[80]; // Buffer zapisovany na display pri refresh_display()
unsigned char i; // Globalni iteracni promenna - bacha na to...
unsigned char index; // 0 az 15 poradove tlacitko na klavesnici
unsigned char sada; // Sada znaku pod klavesami 0 az 3 (casem 4 ci vice)
unsigned char tmp; // Ukladani indexu
unsigned char pozice; // Adresa kurzoru na displeji
unsigned char pruchod; // Pocitadlo poctu preruseni od casovace
unsigned char soubor; // Promenna obsahuje cislo aktualniho programu
unsigned char znaky_m[5][16] = 	{	{'.', 'a', 'd', ' ', 'g', 'j', 'm', ' ', 'p', 't', 'w', ' ', ' ', ' ', ' ', ' '},
					{',', 'b', 'e', ' ', 'h', 'k', 'n', ' ', 'q', 'u', 'x', ' ', ' ', '0', ' ', ' '},
					{'?', 'c', 'f', ' ', 'i', 'l', 'o', ' ', 'r', 'v', 'y', ' ', ' ', ' ', ' ', ' '},
					{'!', '2', '3', ' ', '4', '5', '6', ' ', 's', '8', 'z', ' ', ' ', ' ', ' ', ' '},
					{'1', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '7', ' ', '9', ' ', ' ', ' ', ' ', ' '}
				};
unsigned char znaky_v[5][16] = 	{	{'.', 'A', 'D', ' ', 'G', 'J', 'M', ' ', 'P', 'T', 'W', ' ', ' ', ' ', ' ', ' '},
					{',', 'B', 'E', ' ', 'H', 'K', 'N', ' ', 'Q', 'U', 'X', ' ', ' ', '0', ' ', ' '},
					{'?', 'C', 'F', ' ', 'I', 'L', 'O', ' ', 'R', 'V', 'Y', ' ', ' ', ' ', ' ', ' '},
					{'!', '2', '3', ' ', '4', '5', '6', ' ', 'S', '8', 'Z', ' ', ' ', ' ', ' ', ' '},
					{'1', ' ', ' ', ' ', ' ', ' ', ' ', ' ', '7', ' ', '9', ' ', ' ', ' ', ' ', ' '}
				};

void cekej0u6(char i) {
	while (i != 0) {
		i--;
	}
}

void cekej1u2(short i) {
	while (i != 0) {
		i--;
	}
}

void zapis() {
_asm
	nop
	nop
_endasm;
	PORTD &= 0xf7;
_asm
	nop
	nop
_endasm;
}

void instrukce(char ins, char ctrl, char wait) {
	PORTD = ctrl | (ins & 0xf0);
	zapis();
	cekej0u6(wait);
	PORTD = ctrl | ((ins << 4) & 0xf0);
	zapis();
	cekej0u6(wait);
}

void test_pozice() {
	if (pozice == 255) {
		pozice = 55;
	}
	if (pozice == 16) {
		pozice = 40;
	}
	if (pozice == 39) {
		pozice = 15;
	}
	if (pozice == 56) {
		pozice = 00;
	}
}

void klavesa() {
	// Dokud je nejake tlacitko stisknute
	// bude se stale zjistovat ktere to je
	while (~PORTB & 0xf0) {
		PORTB = 0x07; // Kontrola prvniho radku - na prvnim radku nula
		cekej0u6(100);
		if (PORTBbits.RB7 == 0) index = 0; // 1
		if (PORTBbits.RB6 == 0) index = 1; // 2
		if (PORTBbits.RB5 == 0) index = 2; // 3
		if (PORTBbits.RB4 == 0) index = 3; // A
		PORTB = 0x0b; // Kontrola druheho radku - na druhem radku nula
		cekej0u6(100);
		if (PORTBbits.RB7 == 0) index = 4; // 4
		if (PORTBbits.RB6 == 0) index = 5; // 5
		if (PORTBbits.RB5 == 0) index = 6; // 6
		if (PORTBbits.RB4 == 0) index = 7; // B
		PORTB = 0x0d; // Kontrola tretiho radku - na tretim radku nula
		cekej0u6(100);
		if (PORTBbits.RB7 == 0) index = 8; // 7
		if (PORTBbits.RB6 == 0) index = 9; // 8
		if (PORTBbits.RB5 == 0) index = 10; // 9
		if (PORTBbits.RB4 == 0) index = 11; // C
		PORTB = 0x0e; // Kontrola ctvrteho radku - na ctvrtem radku nula
		cekej0u6(100);
		if (PORTBbits.RB7 == 0) index = 12; // *
		if (PORTBbits.RB6 == 0) index = 13; // 0
		if (PORTBbits.RB5 == 0) index = 14; // #
		if (PORTBbits.RB4 == 0) index = 15; // D
		PORTB = 0x00;
		cekej0u6(100);
	}
}

void refresh_display() {
	instrukce(0x80, 0x08, 70);
	for (i=0; i<80; i++)
		instrukce(buffer[i], 0x0a, 70);
}

void nastav_kurzor() {
	if (pozice < 41) {
		instrukce(0x80 + pozice, 0x08, 70);
	} else {
		instrukce(0x80 + 40, 0x08, 70);
		for (i=pozice-40; i>0; i--) {
			instrukce(0x14, 0x08, 70); //Posune kurzor o pozici vpravo
		}
	}
}

void smaz_display() {
	instrukce(0x01, 0x08, 70);
	cekej1u2(50000);
	for (i=0; i<80; i++)
		buffer[i] = ' ';
	pozice = 0;
	nastav_kurzor();
}

void eewrite(unsigned char znak, unsigned char adresa) {
// BSF STATUS,RP1 ;
// BSF STATUS,RP0
// BTFSC EECON1,WR ;Wait for write
// GOTO $-1 ;to complete
// BCF STATUS, RP0 ;Bank 2
// MOVF DATA_EE_ADDR,W ;Data Memory
// MOVWF EEADR ;Address to write
	EEADR = adresa;
// MOVF DATA_EE_DATA,W ;Data Memory Value
// MOVWF EEDATA ;to write
	EEDATA = znak;
// BSF STATUS,RP0 ;Bank 3
// BCF EECON1,EEPGD ;Point to DATA
// ;memory
	EECON1bits.EEPGD = 0;
// BSF EECON1,WREN ;Enable writes
	EECON1bits.WREN = 1;
// BCF INTCON,GIE ;Disable INTs.
// MOVLW 55h ;
// MOVWF EECON2 ;Write 55h
	EECON2 = 0x55;
// MOVLW AAh ;
// MOVWF EECON2 ;Write AAh
	EECON2 = 0xAA;
// BSF EECON1,WR ;Set WR bit to
// ;begin write
	EECON1bits.WR = 1;
// BSF INTCON,GIE ;Enable INTs.
// BCF EECON1,WREN ;Disable writes
	EECON1bits.WREN = 0;
	while (EECON1bits.WR != 0) {
	// Probiha zapis
	}
}

unsigned char eeread(unsigned adresa) {
// BSF STATUS,RP1 ;
// BCF STATUS,RP0 ; Bank 2
// MOVF DATA_EE_ADDR,W ; Data Memory
// MOVWF EEADR ; Address to read
	EEADR = adresa;
// BSF STATUS,RP0 ; Bank 3
//	STATUSbits.RP0 = 1;
// BCF EECON1,EEPGD ; Point to Data
// ; memory
	EECON1bits.EEPGD = 0;
// BSF EECON1,RD ; EE Read
	EECON1bits.RD = 1;
// BCF STATUS,RP0 ; Bank 2
//	STATUSbits.RP0 = 0;
// MOVF EEDATA,W ; W = EEDATA
	return EEDATA;
}

void zmena_bufferu() {
	unsigned char i;
	for (i=0; i<80; i++) {
		eewrite(buffer[i], 80*soubor+i);
	}
	soubor++;
	if (soubor == POCET_SOUBORU) soubor = 0;
	for (i=0; i<80; i++) {
		buffer[i] = eeread(80*soubor+i);
	}
}

void isr_high() interrupt 1
{
	INTCONbits.GIE = 0;

	if (PIR1bits.TMR1IF == 1) {
		PIR1bits.TMR1IF = 0;

		// Obsluha preruseni od timeru
		pruchod++;
		if (pruchod == 4) {
			sada = 0;
			PORTA |= 0x01;
			T1CONbits.TMR1ON = 0;
			nastav_kurzor();
		}
	}

	if (INTCONbits.RBIF == 1) {
		INTCONbits.RBIE = 0;
		INTCONbits.RBIF = 0;

		klavesa(); // Nastavi index stisknuteho tlacitka
		switch (index) {
		case 3:
			pozice--;
			test_pozice();
			nastav_kurzor();
			break;
		case 7:
			pozice++;
			test_pozice();
			nastav_kurzor();
			break;
		case 11:
			smaz_display();
			break;
		case 12:
			zmena_bufferu();
			pozice = 0;
			refresh_display();
			nastav_kurzor();
			break;
		case 14:
			velikost = !velikost;
			break;
		case 15:
			if (PORTA & 0x02) PORTA &= 0xfd;
			else PORTA |= 0x02;
			break;
		default:
			if (T1CONbits.TMR1ON == 1 && index == tmp) {
				sada += 1;
				if (sada > 4) sada = 0;
				pozice--;
				test_pozice();
			} else {
				sada = 0;
			}
			if (velikost == 0)
				buffer[pozice] = znaky_m[sada][index];
			else
				buffer[pozice] = znaky_v[sada][index];
			refresh_display();
			nastav_kurzor();
			pozice++;
			test_pozice();
			tmp = index;

			TMR1H = TMR1L = 0x00;
			T1CONbits.TMR1ON = 1;
			PIR1bits.TMR1IF = 0;
			PORTA &= 0xfe;
			pruchod = 0;
			break;
		}

		INTCONbits.RBIF = 0;
		INTCONbits.RBIE = 1;
	}
	INTCONbits.GIE = 1;
}

void main(void) {
	unsigned char i;

	ADCON1 = 0x06;
	TRISA = 0x00;
	PORTA = 0x03;
	// PORTD ridi LCD displej
	TRISD = 0x00;
	PORTD = 0x00;
	// RB0 az RB3 vystupy na radky klavesnice
	// RB3 az RB7 vstupy ze sloupcu klavesnice
	TRISB = 0xf0;
	PORTB = 0x00;
	INTCON2bits.RBPU = 0; // Zapnuti pull-up odporu
	INTCONbits.RBIE = 1; // Povoleni preruseni od zmeny stavu na RB4 az RB7
	INTCONbits.RBIF = 0; // Nulovani flagu preruseni od zmeny na RB4 az RB7
	INTCONbits.PEIE = 1; // Povoleni preruseni od periferii
	INTCONbits.GIE = 1; // Globalni povoleni preruseni
	PIE1bits.TMR1IE = 1; // Povoleni preruseni od TMR1
	PIR1bits.TMR1IF = 0; // Nulovani flagu preruseni od TMR1
	T1CONbits.TMR1ON = 0; // Vypnuti TMR1
	T1CONbits.T1CKPS1 = 1;
	T1CONbits.T1CKPS0 = 1;
	pruchod = 0;
	sada = 0;
	velikost = 0;
	soubor = 0;

	for (i=0; i<10; i++)
		cekej1u2(50000); // Velke cekani kvuli displeji

	// Inicializace displeje
	// Nastaveni 4 bitove komunikace

	// Radsi trikrat za sebou (prej prodle datasheetu)
	PORTD = 0x38; // Nastavi 8 bit komunikaci
	zapis();
	cekej1u2(1000);
	PORTD = 0x38; // Nastavi 8 bit komunikaci
	zapis();
	cekej1u2(1000);
	PORTD = 0x38; // Nastavi 8 bit komunikaci
	zapis();
	cekej1u2(1000);

	PORTD = 0x28;
	zapis();
	cekej1u2(1000); // Radsi vic nez min...

	// Donastaveni 4 bitove komunikace, vyber fontu, pocet radku
	instrukce(0x28, 0x08, 70);

	// Zapnuti displeje, kurzoru
	instrukce(0x0e, 0x08, 70);

	// Nastaveni modu zapisovani - posun mista a kurzoru pri zapisu
	instrukce(0x06, 0x08, 70);

#ifdef UVITANI
	// Zapise na oba radky displeje uvitaci obrazovku
	for (i=0; i<80; i++)
			buffer[i] = ' ';
	buffer[0] = 'V';
	buffer[1] = 'i';
	buffer[2] = 'n';
	buffer[3] = 'c';
	buffer[4] = 'e';
	buffer[5] = 'n';
	buffer[6] = 'z';
	buffer[7] = 'o';
	buffer[8] = ' ';
	buffer[9] = 'I';
	buffer[10] = 'n';
	buffer[11] = 'c';
	buffer[12] = '.';

	buffer[40] = 'C';
	buffer[41] = 'o';
	buffer[42] = 'p';
	buffer[43] = 'y';
	buffer[44] = 'r';
	buffer[45] = 'i';
	buffer[46] = 'g';
	buffer[47] = 'h';
	buffer[48] = 't';
	buffer[49] = ' ';
	buffer[50] = '2';
	buffer[51] = '0';
	buffer[52] = '0';
	buffer[53] = '9';

	refresh_display();

	// Podrzeni uvitaci obrazovky
	for (i=0; i<10; i++)
		cekej1u2(50000);
#endif

	if (eeread(0x00) == 0xff) {
		INTCONbits.GIE = 0;
		for (i=0; i<POCET_SOUBORU; i++) {
			smaz_display();
			zmena_bufferu();
		}
		INTCONbits.GIE = 1;
	}

	for (i=0; i<80; i++) {
		buffer[i] = eeread(80*soubor+i);
	}
	refresh_display();
	pozice = 0;
	nastav_kurzor();

	while (1) {

	}
}
